// THIS FILE IS AUTOMATICALLY GENERATED. DO NOT EDIT.

package ses

import (
	"github.com/aws/aws-sdk-go/private/waiter"
)

// WaitUntilIdentityExists uses the Amazon SES API operation
// GetIdentityVerificationAttributes to wait for a condition to be met before returning.
// If the condition is not meet within the max attempt window an error will
// be returned.
func (c *SES) WaitUntilIdentityExists(input *GetIdentityVerificationAttributesInput) error {
	waiterCfg := waiter.Config{
		Operation:   "GetIdentityVerificationAttributes",
		Delay:       3,
		MaxAttempts: 20,
		Acceptors: []waiter.WaitAcceptor{
			{
				State:    "success",
				Matcher:  "pathAll",
				Argument: "VerificationAttributes.*.VerificationStatus",
				Expected: "Success",
			},
		},
	}

	w := waiter.Waiter{
		Client: c,
		Input:  input,
		Config: waiterCfg,
	}
	return w.Wait()
}
